# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UsersRolesPatchRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'user_list': 'list[CspgatewayamapiorgsorgIdrolesUserList]',
        'services_roles_patch_request': 'CspgatewayamapiorgsorgIdrolesServicesRolesPatchRequest'
    }

    attribute_map = {
        'user_list': 'userList',
        'services_roles_patch_request': 'servicesRolesPatchRequest'
    }

    def __init__(self, user_list=None, services_roles_patch_request=None):  # noqa: E501
        """UsersRolesPatchRequest - a model defined in Swagger"""  # noqa: E501
        self._user_list = None
        self._services_roles_patch_request = None
        self.discriminator = None
        self.user_list = user_list
        if services_roles_patch_request is not None:
            self.services_roles_patch_request = services_roles_patch_request

    @property
    def user_list(self):
        """Gets the user_list of this UsersRolesPatchRequest.  # noqa: E501


        :return: The user_list of this UsersRolesPatchRequest.  # noqa: E501
        :rtype: list[CspgatewayamapiorgsorgIdrolesUserList]
        """
        return self._user_list

    @user_list.setter
    def user_list(self, user_list):
        """Sets the user_list of this UsersRolesPatchRequest.


        :param user_list: The user_list of this UsersRolesPatchRequest.  # noqa: E501
        :type: list[CspgatewayamapiorgsorgIdrolesUserList]
        """
        if user_list is None:
            raise ValueError("Invalid value for `user_list`, must not be `None`")  # noqa: E501

        self._user_list = user_list

    @property
    def services_roles_patch_request(self):
        """Gets the services_roles_patch_request of this UsersRolesPatchRequest.  # noqa: E501


        :return: The services_roles_patch_request of this UsersRolesPatchRequest.  # noqa: E501
        :rtype: CspgatewayamapiorgsorgIdrolesServicesRolesPatchRequest
        """
        return self._services_roles_patch_request

    @services_roles_patch_request.setter
    def services_roles_patch_request(self, services_roles_patch_request):
        """Sets the services_roles_patch_request of this UsersRolesPatchRequest.


        :param services_roles_patch_request: The services_roles_patch_request of this UsersRolesPatchRequest.  # noqa: E501
        :type: CspgatewayamapiorgsorgIdrolesServicesRolesPatchRequest
        """

        self._services_roles_patch_request = services_roles_patch_request

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UsersRolesPatchRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UsersRolesPatchRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
